//Primitives de gestion de liste de flottants.
//Par Cyril Cohen

#include <stdlib.h>
#include "listef.h"

liste * l_init(void)
{ liste * l;
  l=(liste *)malloc(sizeof(liste));
  l->debut=l->prec=l->vue=0;
  return l;
}

void l_premier(liste * l)
{ l->vue=l->debut;
  l->prec=NULL;
}

void l_dernier(liste * l)
{ while(l->vue->suiv!=NULL)
     l_suivant(l);
}

void l_suivant(liste * l)
{ if(l->vue->suiv)
   { l->prec=l->vue;
     l->vue=l->vue->suiv;
   }
}

int l_nulle(liste * l)
{ return l->debut==NULL;
}

int l_fin(liste * l)
{ return l->vue->suiv==NULL;
}

float l_lire(liste * l)
{ if(l->vue==NULL)return NULL;
  return l->vue->val;
}

void l_insererapres(liste * l, float x)
{struct cellule * c=(struct cellule *)malloc(sizeof(struct cellule));
 c->val=x;
 c->suiv=NULL;
 if(l->debut==NULL)
   { l->debut=l->vue=c;
     return;
   }
 if(l->vue==NULL)
 { l->prec->suiv=c;
   l->vue=c;
   return;
 }
 c->suiv=l->vue->suiv;
 l->vue->suiv=c;
 l->prec=l->vue;
 l->vue=c;
}

void l_insereravant(liste * l,float x)
{ struct cellule * c=(struct cellule *)malloc(sizeof(struct cellule));
  c->val=x;
  c->suiv=NULL;
  if(l->vue==NULL)
    { l->prec->suiv=l->vue=c;
      return;}
  if(l->prec==NULL)
    { c->suiv=l->debut;
      l->debut=l->vue=c;
      return;
    }
  c->suiv=l->vue;
  l->prec->suiv=c;
  l->vue=c;
  return;
}

void l_oter(liste * l)
{ struct cellule * c;
  if(l->debut==NULL)return;
  if(l->vue==NULL) return;
  if(l->prec==NULL)
  {c=l->vue;l->vue=l->vue->suiv;
   l->debut=l->vue;
   c->suiv=NULL;
   free(c);
   return;
  }
  c=l->vue;
  l->vue=l->vue->suiv;
  l->prec->suiv=l->vue;
  c->suiv=NULL;c->val=NULL;
  free(c);
  return;
}

int l_estvide(liste * l)
{ if(l->debut==NULL) return 1;
  return 0;
}

int l_detruire(liste *l)
{ if(l_estvide(l)) return 1;
  l_premier(l);
  while(!l_estvide(l))
    { l_oter(l);
    }
  return 1;
}


/*void main() {}*/