//PRIMITIVES DE GESTION DE SPRITES

#ifndef SPRITE_H
#define SPRITE_H

#include <allegro.h>

#define SPRITE_MORT   0
#define SPRITE_VIVANT 1
#define MAX_SPRITE_FRAMES 8


typedef struct sprite_typ{ int x,y;               //Position du sprite
                           int hauteur,largeur;   //Dimensions
                           int compteur_1;
                           int compteur_2;
                           int compteur_3;
                           BITMAP *frames[MAX_SPRITE_FRAMES];
                           int curr_frame;
                           int num_frames;
                           int state;
                           BITMAP *background;
                         }sprite, *sprite_ptr;

void sprite_init(sprite_ptr sprite, int x, int y, int hauteur, int largeur, int c1, int c2, int c3);

void sprite_detruit(sprite_ptr sprite);
  
void prendre_sprite(BITMAP *image, sprite_ptr sprite, int sprite_frame, int cell_x, int cell_y);

int collision(sprite_ptr curseur, sprite_ptr menu);

void chargerMario(sprite_ptr sprite);

void chargerCurseur(sprite_ptr sprite);

void dessiner_sprite(sprite_ptr sprite,BITMAP *destination);

void scan_sous_sprite(sprite_ptr sprite, BITMAP *destination);

void effacer_sprite(sprite_ptr sprite, BITMAP *destination);

void setframe(sprite_ptr sprite, int frame);

void setpos(sprite_ptr sprite, int x, int y);

#endif

