//Partie B du projet de statistiques - IUP1 MIAGE - Mai 1998
//compiler avec DJGPP v2.0 et Allegro 3.0

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <math.h>
#include <conio.h>

#include "listef.h"
#include "allegro.h"

typedef struct { liste *clients;
		 liste *tempsserv;
	       } journee, *journee_ptr;



//B_loiexp retourne une valeur simulee de loi exponentielle, de parametre
//specifie dans "param".
//Param : Parametre de la loi exponentielle simulee.
float B_loiexp(float param)
{ float x, res;
  x=random()%1000+1;
  x=x/1000;
  res=-(1/param)*log(x);
  return res;
}

//B_clientjourne remplit une liste avec les arrives des clients.
//l : liste qui contiendra les temps d'arrivee des clients
//dans une journee de 600 minutes.
liste *B_clientsjournee(liste *l, float param)
{ float temp;
  float time=0;
  while(time<600)
    { temp=B_loiexp(param);
      l_insererapres(l,temp);
      time += temp;
    }
  return l;
}

//B_intervalle transforme une liste contenant le temps entre
//chaque arrive en un tableau "tab" de taille "taille"
//reprsentant les arrives par intervalles de "intervalle" minutes.
int *B_intervalle(liste *l, int *tab, int taille, int intervalle)
{ float temp, total=0, courant=0;
  int i=0;
  l_premier(l);
  while(i<taille)
    { temp=l_lire(l);
      while(courant+temp>intervalle)
       { i++;
	 temp-=(intervalle-courant);
	 courant=0;
       }
       tab[i]++;
       courant+=temp;
       total+=temp;
       l_suivant(l);
       if(l_fin(l))
	 break;
       else
	 continue;
    }
  return tab;
}

//Initialise la structure Journe.
journee_ptr j_init(void)
{ journee_ptr j;
  int i;
  j=(journee_ptr)malloc(sizeof(journee));
  if(j==NULL) return NULL;
  j->clients=l_init();
  j->tempsserv=l_init();
  return j;
}

//Libre la mmoire utilise par la structure Journe.
void j_detruit(journee_ptr j)
{ l_detruire(j->clients);
  l_detruire(j->tempsserv);
  free(j);
  j=NULL;
  return;
}


float B_moyenne(int *tab, int taille)
//Retourne la moyenne empirique d'un tableau "tab" de taille "taille".
{ int i;
  float moy=0;
  for(i=0;i<taille;i++)
    moy+=tab[i];
  moy=moy/taille;
  return moy;
}


float B_variance(int *tab, int taille)
//Retourne la variance d'un tableau "tab" de taille "tab".
{ int i;
  float moy,var,ex2;

  moy=B_moyenne(tab,taille);

  for(i=0;i<taille;i++)
    ex2+=tab[i]*tab[i];
  ex2=ex2/taille;
  var=ex2-moy*moy;

  return var;
}

void B_tri (int *t,int taille)
//Effectue le tri par ordre croissant des valeurs
//d'un tableau d'entiers "t" contenant "taille" lments.
{ int i,j,k;
  for(i=0;i<taille-1;i++)
   { for(j=i+1;j<taille;j++)
      { if(t[i]>t[j])
         { k=t[i];
    	   t[i]=t[j];
	   t[j]=k;
         }
      }
   }
 return;
}

//intervalle_de_confiance retourne les bornes "inf"rieures et "sup"rieures
//d'un intervalle de confiance  95%. On utilise une mthode de calcul
//thorique, ce qui donne une trs grande prcision au calcul.
//IC =moy +/- 1,96*sqrt(var)/sqrt(taille);
void intervalle_de_confiance(int *tab, int taille, int *inf, int *sup)
{ float var,moy,borne1,borne2;
  moy=B_moyenne(tab,taille);
  var=B_variance(tab, taille);
  borne1=moy-1.96*sqrt(var)/sqrt(taille);
  borne2=moy+1.96*sqrt(var)/sqrt(taille);
  if( fabs((int)borne1-borne1)<0.5)
    *inf=(int)borne1;
  else
    *inf=((int)borne1)+1;
  if( fabs((int)borne2-borne2)<0.5)
    *sup=(int)borne2;
  else
    *sup=((int)borne2)+1;
  return;
}

//B_gfx_printjournee dessine  l'cran trois graphiques reprsentant
//les arrives par intervalles de 5 minutes, de 10 minutes, et de 15
//minutes pour une seule journe.
//j:  structure journe  afficher
//nb: numro de la journe
//Cette fonction peut tre aussi utilise pour rcuperer les tableaux
//d'intervalles d'arrives. Ainsi tabA, tabB et tabC contiendront
// la sortie de la fonction une copie des tableaux des intervalles
//respectives de 5, 10 et 15 minutes.
void B_gfx_printjournee(journee_ptr j, int nb, int *tabA, int *tabB, int *tabC, float param)
{ int i=0;
  int *tab5, *tab10, *tab15;
  BITMAP *ecran;
  int pixel;

  ecran=create_bitmap(640,480);
  clear(ecran);

  tab5=(int *)malloc(120*sizeof(int));
  for(i=0;i<=119;i++)
    { tab5[i]=0;
    }
  tab10=(int *)malloc(60*sizeof(int));
  for(i=0;i<=59;i++)
    { tab10[i]=0;
    }
  tab15=(int *)malloc(40*sizeof(int));
  for(i=0;i<=39;i++)
    { tab15[i]=0;
    }

  B_intervalle(j->clients,tab5,120,5);
  B_intervalle(j->clients,tab10,60,10);
  B_intervalle(j->clients,tab15,40,15);

  for(i=0;i<120;i++)
    { tabA[nb*120+i]=tab5[i];
    }
  for(i=0;i<60;i++)
    { tabB[nb*60+i]=tab10[i];
    }
  for(i=0;i<40;i++)
    { tabC[nb*40+i]=tab15[i];
    }
  clear(screen);

  pixel=makecol(190,255,190);

  textprintf(ecran,font,10,10,pixel,"Etudes des arrivees - Journee de dix heures numero %d:",nb+1);
  textprintf(ecran,font,10,20,pixel/2,"Arrivees generees par une loi exponentielle de parametre %.1f",param);
  

  pixel=makecol(240,240,240);

  //Dessin des axes
  line(ecran,17,50,17,150,pixel);
  line(ecran,17,150,500,150,pixel);
  textout(ecran,font,"10",0,50,pixel);
  textout(ecran,font,"5",7,95,pixel);
  textout(ecran,font,"0",7,150,pixel);

  line(ecran,220,200,220,350,pixel);
  line(ecran,220,350,470,350,pixel);
  textout(ecran,font,"10",203,250,pixel);
  textout(ecran,font,"5",209,295,pixel);
  textout(ecran,font,"0",209,350,pixel);
  textout(ecran,font,"15",203,200,pixel);

  line(ecran,17,240,17,440,pixel);
  line(ecran,17,440,190,440,pixel);
  textout(ecran,font,"10",0,340,pixel);
  textout(ecran,font,"5",7,385,pixel);
  textout(ecran,font,"0",7,440,pixel);
  textout(ecran,font,"15",0,285,pixel);
  textout(ecran,font,"20",0,240,pixel);

  pixel=makecol(10,50,100);

  textprintf(ecran,font,20,154,pixel,"Arrivees par intervalles de cinq minutes");
  textprintf(ecran,font,220,354,pixel,"Arrivees par intervalles de dix minutes");
  textprintf(ecran,font,20,444,pixel,"Arrivees par intervalles de quinze minutes");

  for(i=0;i<=119;i++)
    { line(ecran,19+4*i,149,19+4*i,149-10*tab5[i],pixel*tab5[i]);
      line(ecran,20+4*i,149,20+4*i,149-10*tab5[i],pixel*tab5[i]);
      line(ecran,21+4*i,149,21+4*i,149-10*tab5[i],pixel*tab5[i]);
    }

  for(i=0;i<=59;i++)
    { line(ecran,222+4*i,349,222+4*i,349-10*tab10[i],pixel*tab10[i]);
      line(ecran,223+4*i,349,223+4*i,349-10*tab10[i],pixel*tab10[i]);
      line(ecran,224+4*i,349,224+4*i,349-10*tab10[i],pixel*tab10[i]);
    }


  for(i=0;i<=39;i++)
    { line(ecran,19+4*i,439,19+4*i,439-10*tab15[i],pixel*tab15[i]);
      line(ecran,20+4*i,439,20+4*i,439-10*tab15[i],pixel*tab15[i]);
      line(ecran,21+4*i,439,21+4*i,439-10*tab15[i],pixel*tab15[i]);
    }

  textprintf(ecran,font,520,30,pixel*50,"Legende :");
  textprintf(ecran,font,500,40,pixel,    "une      arrivee");
  textprintf(ecran,font,500,50,pixel*2,  "deux     arrivees");
  textprintf(ecran,font,500,60,pixel*3,  "trois    arrivees");
  textprintf(ecran,font,500,70,pixel*4,  "quatre   arrivees");
  textprintf(ecran,font,500,80,pixel*5,  "cinq     arrivees");
  textprintf(ecran,font,500,90,pixel*6,  "six      arrivees");
  textprintf(ecran,font,500,100,pixel*7, "sept     arrivees");
  textprintf(ecran,font,500,110,pixel*8, "huit     arrivees");
  textprintf(ecran,font,500,120,pixel*9, "neuf     arrivees");
  textprintf(ecran,font,500,130,pixel*10,"dix      arrivees");
  textprintf(ecran,font,500,140,pixel*11,"onze     arrivees");
  textprintf(ecran,font,500,150,pixel*12,"douze    arrivees");
  textprintf(ecran,font,500,160,pixel*13,"treize   arrivees");
  textprintf(ecran,font,500,130,pixel*10,"dix      arrivees");
  textprintf(ecran,font,500,140,pixel*11,"onze     arrivees");
  textprintf(ecran,font,500,150,pixel*12,"douze    arrivees");
  textprintf(ecran,font,500,160,pixel*13,"treize   arrivees");
  textprintf(ecran,font,500,170,pixel*14,"quatorze arrivees");
  textprintf(ecran,font,500,180,pixel*15,"quinze   arrivees");
  textprintf(ecran,font,500,190,pixel*16,"seize    arrivees");
  textprintf(ecran,font,500,200,pixel*17,"dix-sept arrivees");
  textprintf(ecran,font,500,210,pixel*18,"dix-huit arrivees");
  textprintf(ecran,font,500,220,pixel*19,"dix-neuf arrivees");
  textprintf(ecran,font,500,230,pixel*20,"vingt    arrivees");

  textprintf(ecran,font,420,450,pixel*45,"Cliquez pour continuer...");

  blit(ecran,screen,0,0,0,0,640,480);

  destroy_bitmap(ecran);

  free(tab5);
  free(tab10);
  free(tab15);
  tab5=NULL;
  tab10=NULL;
  tab15=NULL;
  return;

}

//B_arrivees est la fonction principale de la partie B.
void B_arrivees(float parametre)
{ int i,journee=0,inf,sup,pixel,*tab5,*tab10, *tab15;
  float moy5,moy10,moy15,var5,var10,var15;
  journee_ptr j;
  BITMAP *ecran;

  ecran=create_bitmap(640,480);

  j=j_init();

  tab5=(int *)malloc(3000*sizeof(int));
  for(i=0;i<3000;i++)
    { tab5[i]=0;
    }
  tab10=(int *)malloc(1500*sizeof(int));
  for(i=0;i<1500;i++)
    { tab10[i]=0;
    }
  tab15=(int *)malloc(1000*sizeof(int));
  for(i=0;i<1000;i++)
    { tab15[i]=0;
    }

  //Impression des 25 journes
  for(journee=0;journee<25;journee++)
   { clrscr();
     B_clientsjournee(j->clients,parametre);
     B_gfx_printjournee(j, journee, tab5, tab10, tab15, parametre);
     l_detruire(j->clients);
     while(!(mouse_b&1))
       {}
   }

  //Tri des valeurs des tableaux

  B_tri(tab5,3000);
  B_tri(tab10,1500);
  B_tri(tab15,1000);

  //Calculs
  moy5=B_moyenne(tab5,3000);
  var5=B_variance(tab5,3000);
  moy10=B_moyenne(tab10,1500);
  var10=B_variance(tab10,1500);
  moy15=B_moyenne(tab15,1000);
  var15=B_moyenne(tab15,1000);

  intervalle_de_confiance(tab15,1000,&inf,&sup);

  clear(screen);
  clear(ecran);

  pixel=makecol(230,220,100);

  //Affichage des rsultats:

  textout(ecran,font,"Peut-on approximer ces arrivees (par intervalle de longueur fixe)",50,40,pixel);
  textout(ecran,font,"par une loi statistique de Poisson ?",150,50,pixel);

  pixel=makecol(50,100,220);

  textprintf(ecran,font,40,100,pixel,"Intervalles de  5 minutes : moyenne = %.2f , variance = %.2f",moy5,var5);
  textprintf(ecran,font,40,110,pixel,"            de 10 minutes :         = %.2f ,          = %.2f",moy10,var10);
  textprintf(ecran,font,40,120,pixel,"            de 15 minutes :         = %.2f ,          = %.2f",moy15,var15);

  textprintf(ecran,font,40,200,pixel,"Intervalle de confiance a 95%% pour 5 minutes : IC5  [ %2d; %2d]",tab5[75],tab5[2924]);
  textprintf(ecran,font,40,210,pixel,"                                   10 minutes : IC10 [ %2d; %2d]",tab10[50],tab10[1450]);
  textprintf(ecran,font,40,220,pixel,"                                   15 minutes : IC15 [ %2d; %2d]",tab15[25],tab15[974]);

  pixel=makecol(100,100,220);

  textprintf(ecran,font,40,300,pixel,"Intervalle de confiance a 95%% pour 15 minutes (autre methode de calcul):");
  pixel=makecol(80,100,220);
  textprintf(ecran,font,260,310,pixel,"[ %d , %d ]",inf,sup);

  pixel=makecol(230,220,100);

  if( ( fabs(moy5-var5)<0.4)&&(fabs(moy10-var10)<0.5)&&(fabs(moy15-var15)<0.4))
    { textprintf(ecran,font,85,350,pixel,"On peut effectivement approximer la loi generant les");
      textprintf(ecran,font,125,360,pixel,"arrivees par une loi de Poisson.");
    }
  else
    { textprintf(ecran,font,65,350,pixel,"On ne peut point simuler ces arrives par une loi de Poisson.");
      textprintf(ecran,font,105,360,pixel,"Notre simulation ne marche pas du tout...");
    }

  pixel=makecol(200,40,50);

  textprintf(ecran,font,150,430,pixel,"CLICKEZ POUR REVENIR AU MENU PRINCIPAL");


  blit(ecran,screen,0,0,0,0,640,480);

  while(!(mouse_b&1))
  {}

  destroy_bitmap(ecran);

  j_detruit(j);
  j=NULL;

  free(tab5);
  free(tab10);
  free(tab15);
  tab5=tab10=tab15=NULL;
  clear(screen);

  return;
}


