//Projet de statistiques - IUP 1 MIAGE - MAI 98
//PARTIE C
//programme  compiler avec DJGPP v2.0 et Allegro v3.0


#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <math.h>
#include <conio.h>
#include <crt0.h> //Fonctions de dbugging.
#include <time.h> //Pour recuperer le temps.

#include "listef.h"
#include "statb.h"
#include "allegro.h"

#define MAX_MINUTES 600

typedef struct gui{ int occupe;           //Etat actuel du guichet.
		    float temps_total;    //Temps total de service du client actuel.
		    float temps_servi;    //Temps de service pass du client actuel.
		    float temps_inoccupe; //Temps total d'innocupation.
		    int nb_clients_file;  //Nombre de clients dans la file.
                    int servis;           //Nombre total de clients servis.
                    int nb_clients_cumul;  //Nombre total de clients passs dans la file.
                    int nb_variations_file;//Nombre de variations de la file.
                    liste *file;          //Temps de traitement des clients.
	          }guichet;

liste *C_services(float param)
//l : liste qui contiendra les temps d'attente des clients
//dans une journee de 600 minutes.
{ liste *l;
  float temp;
  float time=0;
  l=l_init();
  while(time<600)
    { temp=B_loiexp(param);
      l_insererapres(l,temp);
      time += temp;
    }
  return l;
}

//fonction d'initialisation de la structure guichet
guichet *init_guichet(void)
{ guichet *g;
  g=(guichet *)malloc(sizeof(struct gui));
  g->occupe=0;
  g->temps_total=0;
  g->temps_servi=0;
  g->temps_inoccupe=0;
  g->nb_clients_file=0;
  g->servis=0;
  g->nb_clients_cumul=0;
  g->nb_variations_file=0;
  g->file=l_init();
  return g;
}

//Fonction de traitment du guichet en une seule unit de temps
//(0.01 minutes) avec une slection du client suivant selon
//une mthode FIFO.
void guichet_FIFO(journee *j, guichet *g, float intervalle, long temps)
{ if(g->occupe==1)                       //Si le guichet est occup,
    { g->temps_servi+=0.01;              //On continue a servir le client.
      if(g->temps_servi>=g->temps_total) //Si on a fini avec le client,
        { g->occupe=0;                   //on libre le guichet.
          g->temps_total=0;
          g->temps_servi=0;
          g->servis++;
        }
    }

  if(!g->occupe)                        //Si le guichet est libre,
    { if(g->nb_clients_file==0)         //et il n'y a pas de clients,
        { g->temps_inoccupe+=0.01;      //alors on garde son temps
        }                               //d'innocupation.
      else                              //Mais s'il y a des clients,
        { l_premier(g->file);           //Slection FIFO = Premier arriv.
          g->occupe=1;                  //Le guichet devient occup.
          g->temps_total=l_lire(g->file);//On rcupre le temps de
          l_oter(g->file);              //traitement et on enlve le
          g->nb_clients_file--;         //client de la file.

          g->nb_variations_file++;
          g->nb_clients_cumul+=g->nb_clients_file;
        }
    }
  return;
}

//Fonction de traitement d'une journe.
//On n'effectue aucun affichage pour gagner de la vitesse.
//Cette mme fonction lgrement modifie est utilise en
//partie D pour faire la reprsentation graphique.
float C_journee(float param1, float param2, float *moyenne_file)
{ long temps=0;               //temps en centimes de minutes.
  float intervalle=0,ts,inoc; //ts = temps entre deux arrives
  long i;
  int rejets=0;

  guichet *g;
  journee *j;

  g=init_guichet();
  j=j_init();

  j->clients=C_services(param1);
  j->tempsserv=C_services(param2);

  l_premier(j->clients);
  l_premier(j->tempsserv);

  //Boucle principale
  //On simule en "temps rel" la journe.
  //Cela se fait en utilisant le temps comme paramtre non modifiable
  //par les fonctions et modifi indpendamment du reste (d'o le nom
  //de "temps rel" car le temps avance indpendamment des
  //oprations effectues.
  while(temps<=MAX_MINUTES*100)
    { //Stratgie FIFO
      //Si un client arrive on l'insre dans la file.

      intervalle+=0.01;

      //On suppose qu'il y a une seule file d'attente par guichet.
      //Comme on a un seul guichet on insere tout client arriv dans
      //sa file d'attente.

      //En utilisant exactement la mme structure de guichet,
      //on pourrait construire une simulation d'une infinit de
      //guichets (on serait uniquement limits par la place mmoire)
      //avec chacun sa file d'attente. Dans ce cas, il faudrait
      //ventuellement prvoir des changements de file pour les "clients".
      //Ou bien on pourrait utiliser une liste de clients "g->file"
      //extrieure pour simuler plusieurs guichets avec une seule
      //file d'attente.

      if(l_estvide(j->clients))  //S'il n'y a plus de clients dans
        break;                   //la journe, il n'est pas ncessaire
      if(l_estvide(j->tempsserv))//de continuer le traitement.
        break;
        { ts=l_lire(j->clients); //On garde le temps d'intervalle.
          if( intervalle>=ts )
            { ts=l_lire(j->tempsserv);
              if( temps+((int)ts*100) > (MAX_MINUTES*100))
               { rejets++;       //Si le temps de service est suprieur  la
                                 //fermeture alors on rejette le client.
               }
              else
                { l_insererapres(g->file,ts); //Sinon on insre le client
                  g->nb_clients_file++;       //dans la file.

                  g->nb_variations_file++;    //Paramtres pour le calcul
                  g->nb_clients_cumul+=g->nb_clients_file;//de la longueur
                }                                         //moyenne de la file
              l_oter(j->tempsserv);
              l_oter(j->clients);
              intervalle=0;
            }
        }

      //Traitement du guichet pour une unit de temps.

      guichet_FIFO(j,g,intervalle,temps);

      temps++; //on passe  l'unit de temps suivante.
    }


  j_detruit(j);

  //Calcul de la moyenne de la longueur de la file:
  *moyenne_file=g->nb_clients_cumul/g->nb_variations_file;

  //Calcul de la moyenne du temps d'inoccupation entre deux clients:
  inoc=g->temps_inoccupe/g->servis;
  if(g->file)
    free(g->file);
  free(g);
  return inoc;
}

//Procdure de tri d'un tableau de nombres  virgule flottante.
void C_tri_float(float *t,int taille)
{ int i,j;
  float k;
  for(i=0;i<taille-1;i++)
   { for(j=i+1;j<taille;j++)
      { if(t[i]>t[j])
         { k=t[i];
      	   t[i]=t[j];
      	   t[j]=k;
	 }
      }
   }
 return;
}


int C_file(float param1, float param2)
//Partie C.
//Temps de traitement des calculs des 100 journes sur un
//pentium 233 mmx: 6 secondes.
{ float inoccupation[100];
  int i,pixel;
  float longueur_file[100];
  BITMAP *ecran;
  ecran=create_bitmap(640,480);

  clear(ecran);
  pixel=makecol(200,200,100);

  textprintf(ecran,font,180,230,pixel,"Veuillez patienter... calculs en cours...");
  textprintf(ecran,font,10,240,pixel/2,"Generation de 100 journees avec des arrivees suivant une loi exponentielle");
  textprintf(ecran,font,10,250,pixel/2,"de parametre %.1f et des temps de service suivant la meme loi de parametre %.1f",param1,param2);

  blit(ecran,screen,0,0,0,0,640,480);

  for(i=0;i<100;i++)
   { inoccupation[i]=C_journee(param1,param2,&longueur_file[i]);
   }

  C_tri_float(inoccupation,100);
  C_tri_float(longueur_file,100);

  clear(screen);
  clear(ecran);

  textprintf(ecran,font,50,100,pixel*28,"L'intervalle de confiance a 95%% du temps d'inoccupation est: [%.2f, %.2f]",inoccupation[3],inoccupation[98]);
  textprintf(ecran,font,60,110,pixel*28,"et celui de la longueur moyenne de la file est: [%.2f,%.2f]",longueur_file[3],longueur_file[98]);

  textprintf(ecran,font,150,200,pixel/18,"clickez pour retourner au menu");

  blit(ecran,screen,0,0,0,0,640,480);

  while(!(mouse_b&1))
     {}

  destroy_bitmap(ecran);

  return 0;
}


