//Projet de statistiques - IUP 1 MIAGE - Mai 98
//Partie D - Reprsentation graphique

//A compiler avec DJGPP v2.0 et Allegro v3.0

#include "statb.h"
#include "statc.h"
#include "allegro.h"
#include "sprite.h"


//Les fonctions ici prsentes sont basiquement les mmes que celles
//de la partie C. Cependant la diffrence rside dans le fait que l'on
//simule une seule journe et on fait un affichage graphique anim
//en "temps rel" pour cette journe.

//On peut rduire la prcision du temps pour plus de vitesse. En effet,
//le calcul prendrait une heure (6 secondes par minute) sur un pentium  233
//MhZ en vitesse "lente".

//D_guichet_FIFO: traitement du guichet selon une unit de temps:
//j et g: les structures de la journe et du guichet
//intervalle: l'intervalle de temps coul
//temps: le temps courant
//mario[]: les sprites
//vitesse: (0 ou 1) la vitesse de simulation
void D_guichet_FIFO(journee *j, guichet *g, float intervalle, long temps, sprite mario[],int vitesse)
{ int i,inf=0,trouve;
  if(g->occupe==1)                       //Si le guichet est occup,
    {                                    //on continue a servir le client.
      if(vitesse)
         g->temps_servi+=0.1;
      else
         g->temps_servi+=0.01;

      if(g->temps_servi>=g->temps_total) //Si on a fini avec le client,
        { g->occupe=0;                   //on libre le guichet.
          g->temps_total=0;
          g->temps_servi=0;
          g->servis++;
          inf=0;
          trouve=0;

          //Pour la reprsentation graphique, on doit slectionner
          //le sprite qui a t servi. Pour cela, on utilise des compteurs.
          //Ainsi si un sprite a t servi pendant qu'il arrivait au guichet,
          //il continue son chemin.
          for(i=0;i<20;i++)
            { if(mario[i].compteur_1==4)
               { mario[i].compteur_1=5;
                 mario[i].compteur_2=0;
                 trouve=1;
               }
            }
          if(!trouve) //si aucun client dans la caisse, on prend celui qui arrive.
            { for(i=0;i<20;i++)
               { if(mario[i].compteur_1==3)
                  { mario[i].compteur_1=5;
                    mario[i].compteur_2=0;
                     trouve=1;
                  }
               }
            }
        }
    }

  if(!g->occupe)                        //Si le guichet est libre,
    { if(g->nb_clients_file==0)         //et il n'y a pas de clients,
        { if(vitesse)
            g->temps_inoccupe+=0.1;      //alors on garde son temps
          else                            //d'inoccupation.
            g->temps_inoccupe+=0.01;
        }
      else                              //Mais s'il y a des clients,
        { l_premier(g->file);           //Slection FIFO = Premier arriv.
          g->occupe=1;                  //Le guichet devient occup.
          g->temps_total=l_lire(g->file);//On rcupre le temps de
          l_oter(g->file);              //traitement et on enlve le
          g->nb_clients_file--;         //client de la file.
          //On doit prendre un des sprites de la file d'attente.
          //On doit aussi prendre le plus  gauche (le premier).
          //Premier pas: choix du premier sprite de la file.
          for(i=0;i<20;i++)
            { if((mario[i].compteur_1==2)||(mario[i].compteur_1==1))
                { inf=i;
                  break;
                }
            }
          //deuxime pas: on verifie si c'est le plus  gauche.
          for(i=0;i<20;i++)
            { if((mario[i].compteur_1==2)||(mario[i].compteur_1==1))
              //si le sprite est dans la file ou y va.
                { if(mario[inf].x > mario[i].x)
                   { inf=i;
                   }
                }
            }
          //On "l'active".
          if((mario[inf].compteur_1==2)||(mario[inf].compteur_1==1))
          //prcaution dans le cas o aucun sprite dans la file.
            { mario[inf].compteur_1=3;
              mario[inf].compteur_2=200;
            }

          for(i=0;i<20;i++)//Dcalage des autres sprites.
            { if((mario[i].compteur_1==2)||(mario[i].compteur_1==1))
                 mario[i].compteur_2-=20;

            }
        }
    }
  return;
}

float D_gfx_journee(float param1, float param2, int *moyenne_file, int vitesse)
//On a au maximum 20 personnes attendant au guichet (limite pour avoir
//assez de mmoire libre) Si jamais plus de 20 personnes sont au guichet,
//on verrait des "hommes invisibles" mais tout devrait marcher
//normalement.
{ long temps=0;          //temps en centimes de minutes.
  float intervalle=0,ts; //temps entre deux arrives
  long i;
  int rejets=0,inoc,trouve=0,inf=0,pixel,frame=0,fcaisse=0;

  guichet *g;
  journee *j;

  BITMAP *ecran,*terre,*dessin;
  PALETTE pal;
  sprite mario[20], caisse;

  dessin=create_bitmap(100,34);
  dessin=load_pcx("caisse.pcx",pal);
  sprite_init((sprite_ptr)&caisse,0,0,32,32,0,0,0);
  for(frame=0;frame<3;frame++)
    prendre_sprite(dessin,(sprite_ptr)&caisse,frame,frame,0);
  destroy_bitmap(dessin);

  ecran=create_bitmap(640,480);
  clear(ecran);
  terre=create_bitmap(16,32);
  clear(terre);

  terre=load_pcx("terre.pcx",pal);

  g=init_guichet();
  if(!g->file)
    g->file=l_init();
  j=j_init();

  j->clients=B_clientsjournee(j->clients,param1);
  j->tempsserv=C_services(param2);

  l_premier(j->clients);
  l_premier(j->tempsserv);

  //Initialisation des sprites.

  for(i=0;i<20;i++)
        { chargerMario((sprite_ptr)&mario[i]);
          setpos((sprite_ptr)&mario[i],640,400);
          mario[i].compteur_1=0;
          mario[i].compteur_2=640;
          scan_sous_sprite((sprite_ptr)&mario,ecran);
        }

  setpos((sprite_ptr)&caisse,168,400);
  scan_sous_sprite((sprite_ptr)&caisse,ecran);

  //Boucle principale
  while(temps<=MAX_MINUTES*100)
    { clear(ecran);
      //Dessin de l'cran et du dcor:
      for(i=0;i<640;i+=16)
         blit(terre,ecran,0,0,i,431,16,32);
      for(i=330;i<431;i++)
         { pixel=makecol(255-(431-i),255-(431-i),255);
           line(ecran,0,i,640,i,pixel);
         }
      pixel=makecol(255,255,0);

      for(i=0;i<3;i++)
         line(ecran,317+i,432,317+i,434,pixel);

      if(vitesse)
        { if(temps%100/10==7||temps%100/10==3)
           { if(g->occupe)
             { fcaisse++;
               if(fcaisse>2)
               fcaisse=0;
             }
          else
               fcaisse=0;
            setframe((sprite_ptr)&caisse,fcaisse);
           }
        }
      else
        { if(temps%10==7||temps%100%10==3)
           { if(g->occupe)
             { fcaisse++;
               if(fcaisse>2)
               fcaisse=0;
             }
          else
               fcaisse=0;
            setframe((sprite_ptr)&caisse,fcaisse);
           }
        }


      dessiner_sprite((sprite_ptr)&caisse,ecran);

      if(vitesse)
         intervalle+=0.1;
      else
         intervalle+=0.01;

      //On suppose qu'il y a une seule file d'attente par guichet.
      //Comme on a un seul guichet on insere tout client arriv dans
      //sa file d'attente.
      if(l_estvide(j->clients))  //S'il n'y a plus de clients dans
        break;                   //la journe, il n'est pas ncessaire
      if(l_estvide(j->tempsserv))//de continuer le traitement.
        break;
        { ts=l_lire(j->clients);
          if( intervalle>=ts )
            { if( temps+((int)ts*100) > (MAX_MINUTES*100))
               { rejets++;
               }
              else                               //Insertion d'un client dans
                                                 //la liste.
                { ts=l_lire(j->tempsserv);
                  l_insererapres(g->file,ts);
                  g->nb_clients_file++;

                  for(i=0;i<20;i++)
                    { if(mario[i].compteur_1==0)
                       { mario[i].compteur_1=1;       //Nouvel tat
                         mario[i].compteur_2=300+g->nb_clients_file*20;//nouvelle position
                         break;                      //Ds qu'on trouve un
                       }                             //on sort.
                    }

                }
              l_oter(j->tempsserv);
              l_oter(j->clients);
              intervalle=0;
            }
        }

      //Traitement du guichet.

      D_guichet_FIFO(j,g,intervalle,temps,mario,vitesse);

      //Fin traitement guichet

      for(i=0;i<20;i++)                              //Traitement des sprites
        { if((mario[i].compteur_1==2)&&(mario[i].x>mario[i].compteur_2))
            { mario[i].x-=8;
              frame++;
              setframe((sprite_ptr)&mario[i],frame);
              frame--;
            }
          if((mario[i].compteur_1==1)||(mario[i].compteur_1==3)||(mario[i].compteur_1==5))
          //Si en dplacement
            { if(mario[i].x > mario[i].compteur_2)
                { mario[i].x-=8;
                  frame++;
                  if(frame>2)
                    frame=0;
                  setframe((sprite_ptr)&mario[i],frame);
                }
              else
                { setframe((sprite_ptr)&mario[i],0);
                  if(mario[i].compteur_1==1)     //Si on arrive  la file,
                    mario[i].compteur_1=2;       //alors tat = dans la file.
                  if(mario[i].compteur_1==3)     //Si on arrive  la caisse,
                    mario[i].compteur_1=4;       //alors tat = dans la caisse.
                  if(mario[i].compteur_1==5)     //Si on sort de l'cran,
                    { mario[i].compteur_1=0;     //alors tat = prt  l'usage.
                      mario[i].compteur_2=640;
                      mario[i].x=640;
                    }
                }
            }//Fin si en dplacement.

          scan_sous_sprite((sprite_ptr)&mario[i],ecran);
          dessiner_sprite((sprite_ptr)&mario[i],ecran);
         }//Fin for i.

      textprintf(ecran,font,120,10,20394,"Representation graphique d'une journee de 600 minutes.");
      textprintf(ecran,font,50,20,20300,"Les arrivees sont generees par une loi exponentielle de parametre %.1f",param1);
      textprintf(ecran,font,70,30,20300,"et les temps de service par une loi exponentielle de parametre %.1f .",param2);

      textprintf(ecran,font,220,60,45678,"Temps total= %d,%d minutes",temps/100,temps%100);
      textprintf(ecran,font,170,120,45678,"Temps depuis la derniere arrivee: %.2f",intervalle);
      textprintf(ecran,font,180,130,45678,"Temps de la prochaine arrivee : %.2f",ts);
      textprintf(ecran,font,175,180,45678,"Nombre de clients dans la file = %d",g->nb_clients_file);
      if(g->occupe)
       { pixel=makecol(255,0,0);
         textprintf(ecran,font,240,230,pixel,"Le guichet est occupe.");
         textprintf(ecran,font,160,270,45678,"Client en traitement depuis %.2f minutes.",g->temps_servi);
         textprintf(ecran,font,160,280,45678,"Temps total de traitement du client : %.2f",g->temps_total);
       }
      else
       { pixel=makecol(0,255,0);
         textprintf(ecran,font,240,230,pixel,"Le guichet est libre.");
         textprintf(ecran,font,160,270,45678,"Temps total d'inoccupation: %.2f minutes.",g->temps_inoccupe);
       }
      textprintf(ecran,font,180,300,45678,"%d clients ont ete servis aujourd'hui.",g->servis);

      textprintf(ecran,font,130,460,456780,"Appuyez sur <ESPACE> pour arreter la simulation");

      blit(ecran,screen,0,0,0,0,640,480);

      if(key[KEY_SPACE])
         break;

    if(vitesse)
       temps+=10;
    else
       temps+=1;
    }

  j_detruit(j);
  inoc=g->temps_inoccupe;

  if(g->file)
    free(g->file);
  free(g);

  moyenne_file=0;


  for(i=0;i<20;i++)
        { sprite_detruit((sprite_ptr)&mario[i]);
        }


  return inoc;
}
